%{!?tcl_version: %global tcl_version %(echo 'puts $tcl_version' | tclsh || echo 0.0)}
%{!?tcl_sitearch: %global tcl_sitearch %{_libdir}/tcl%{tcl_version}}

Summary: A library for generating Macromedia Flash files
Name: ming
Version: 0.4.5
Release: 9%{?dist}
URL: http://www.libming.org/
Source0: http://downloads.sourceforge.net/project/ming/Releases/ming-%{version}.tar.bz2
# make ming-config multilib-compatible
Patch0: ming-multilib.patch
# install perl modules to vendorarch dir and link dynamically with libming.so
Patch1: ming-perl.patch
License: LGPLv2+
BuildRequires: bison
BuildRequires: flex
BuildRequires: freetype-devel
BuildRequires: giflib-devel
BuildRequires: libpng-devel
BuildRequires: swig

%description
Ming is a library for generating Macromedia Flash files (.swf), written in C,
and includes useful utilities for working with .swf files.

%package devel
Summary: A library for generating Macromedia Flash files - development files
Requires: %{name}%{_isa} = %{version}-%{release}

%description devel
Ming is a library for generating Macromedia Flash files (.swf), written in C,
and includes useful utilities for working with .swf files.

This package contains the development files.

%package utils
Summary: Utilities for generating Macromedia Flash files
Requires: %{name} = %{version}-%{release}

%description utils
A set of utility programs for generating Macromedia Flash files using the Ming
library.

%package perl
Summary: A Perl module for generating Macromedia Flash files using the Ming library
Provides: perl-SWF = %{version}-%{release}
Provides: perl-SWF%{_isa} = %{version}-%{release}
BuildRequires: perl(Cwd)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(strict)
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description perl
A perl module for generating Macromedia Flash files using the Ming library.

%package php
Summary: A PHP module for generating Macromedia Flash files using the Ming library
BuildRequires: php-devel
Requires: php(zend-abi) = %{php_zend_api}
Requires: php(api) = %{php_core_api}

%description php
A PHP module for generating Macromedia Flash files using the Ming library.

%package python
Summary: A Python module for generating Macromedia Flash files using the Ming library
BuildRequires: python2-devel

%description python
A Python module for generating Macromedia Flash files using the Ming library.

%package tcl
Summary: A TCL module for generating Macromedia Flash files using the Ming library
BuildRequires: tcl-devel
Requires: tcl(abi) = %{tcl_version}

%description tcl
A TCL module for generating Macromedia Flash files using the Ming library.

%prep
%setup -q
%patch0 -p1 -b .multilib
%patch1 -p1 -b .p
pushd src
chmod -x actioncompiler/{compile,listaction}.* blocks/{matrix,outputblock}.* \
         displaylist.* position.*
popd
iconv -f iso8859-1 -t utf8 -o ChangeLog.utf8 ChangeLog && \
touch -r ChangeLog ChangeLog.utf8 && \
mv ChangeLog.utf8 ChangeLog

# force rebuild of python bindings
rm py_ext/ming_wrap.c

%build
%configure \
  --disable-silent-rules \
  --disable-static \
  --enable-cpp \
  --enable-perl \
  --enable-php \
  --enable-python \
  --enable-tcl \

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make V=1 %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install
rm %{buildroot}%{_libdir}/libming.la
rm %{buildroot}%{_libdir}/perl5/perllocal.pod
rm -f %{buildroot}%{perl_vendorarch}/auto/SWF/{.packlist,SWF.bs}
chmod 755 %{buildroot}%{perl_vendorarch}/auto/SWF/SWF.so
rm %{buildroot}%{_libdir}/ming/tcl/mingc.la
install -d %{buildroot}%{tcl_sitearch}/ming
mv %{buildroot}%{_libdir}/ming/tcl/mingc.so %{buildroot}%{tcl_sitearch}/ming/

%if 1
%check
LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir} make check
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc AUTHORS COPYING ChangeLog HISTORY NEWS README TODO
%{_libdir}/libming.so.*

%files devel
%{_bindir}/ming-config
%{_includedir}/ming.h
%{_includedir}/mingpp.h
%{_libdir}/libming.so
%{_libdir}/pkgconfig/libming.pc

%files utils
%doc util/README util/TIPS util/ming.css util/swftoperl.html
%{_bindir}/dbl2png
%{_bindir}/gif2dbl
%{_bindir}/gif2mask
%{_bindir}/listaction
%{_bindir}/listaction_d
%{_bindir}/listfdb
%{_bindir}/listjpeg
%{_bindir}/listmp3
%{_bindir}/listswf
%{_bindir}/listswf_d
%{_bindir}/makefdb
%{_bindir}/makeswf
%{_bindir}/png2dbl
%{_bindir}/raw2adpcm
%{_bindir}/swftocxx
%{_bindir}/swftoperl
%{_bindir}/swftophp
%{_bindir}/swftopython
%{_bindir}/swftotcl

%files perl
%dir %{perl_vendorarch}/auto/SWF
%{perl_vendorarch}/auto/SWF/SWF.so
%{perl_vendorarch}/SWF.pm
%dir %{perl_vendorarch}/SWF
%{perl_vendorarch}/SWF/*.pm
%{_mandir}/man3/SWF*.3pm*

%files php
%{php_extdir}/ming.so

%files python
%{python2_sitearch}/_mingc.so
%{python2_sitearch}/ming.py*
%{python2_sitearch}/mingc.py*
%{python2_sitearch}/mingc-*.egg-info

%files tcl
%{tcl_sitearch}/ming

%changelog
* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.5-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.5-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Jun 03 2015 Jitka Plesnikova <jplesnik@redhat.com> - 0.4.5-7
- Perl 5.22 rebuild

* Wed Aug 27 2014 Jitka Plesnikova <jplesnik@redhat.com> - 0.4.5-6
- Perl 5.20 rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jun 20 2014 Remi Collet <rcollet@redhat.com> - 0.4.5-4
- rebuild for https://fedoraproject.org/wiki/Changes/Php56

* Fri Jun 06 2014 Dominik Mierzejewski <rpm@greysector.net> - 0.4.5-3
- add missing perl module Provides and BRs

* Tue May 27 2014 Dominik Mierzejewski <rpm@greysector.net> - 0.4.5-2
- fix ming-config to be multilib-compatible
- enable testsuite
- disable silent rules in configure call
- drop defattr
- build perl, php, python and tcl bindings
- don't change ChangeLog timestamp

* Sun May 25 2014 Dominik Mierzejewski <rpm@greysector.net> - 0.4.5-1
- initial build
